Subject: CD-ROM distributions and the GPL
From: [email-masked] (Richard Stallman)
Date: 4 Jan 1994 22:44:16 GMT
Newsgroups: comp.os.linux.announce

I've been told that people are distributing CD-ROMS of Linux binaries
which include neither the source code nor a written offer to supply
source code later.

The GPL says that any distribution of binaries must contain either the
source code or a written offer to supply source code (see the GPL for
details of what is required).

There are other ways to distribute GNU source in other ways (ftp,
telephone downloading, etc) but they don't fill the requirements to go
with a binary distributed on physical media.

In itself, distributing GNU programs by ftp is a fine thing, and
there's no problem when people who happen to be on the network get
copies that way.  But when someone gets a binary on physical media
(such as a CD-ROM), he may not be on the network.  Telling him to "get
the sources by ftp" is not satisfactory in general.

In general, a distributor is not going to satisfy the GPL by making a
CD-ROM from whatever is present on a single ftp site.  This is because
it is common for two ftp sites to cooperate, one providing binaries
and the other providing source.  (Such cooperation is ok assuming any
user who can ftp binaries from one site can also ftp the source from
the other.)  A proper CD-ROM that includes the binary from one site
must also include the source from the other site.

Please help the FSF remind these distributors to clean up their acts.
In order to take action, we need to know who is distributing such
CD-ROMs, and how to reach them (including a snail address).  So if you
know of such a CD-ROM, please send mail to [email-masked]
with details.

(Please double-check the CD-ROM, to make sure it really does not
contain source code or a suitable written offer, before you complain
about it!)

All these points apply to floppies as well as CD-ROMs.

I've also heard that sometimes binaries of GPL-covered software are
distributed with only diffs, not complete sources for the programs.
This doesn't satisfy the GPL, because if you distribute binaries you
must also distribute the complete sources.

Here is more explanation about the reasons for these requirements,
in the form of answers to two hypothetical questions.

* I want to distribute binaries without accompanying sources.
  Instead of sending source code later to users who order it, can I
  just put the source where users can get it by anonymous FTP?

You are welcome to make the source code for any version of GNU
software available by anonymous FTP, but this is not sufficient to
satisfy section 3 of the GPL.

When a user says he wants the source, you have to make sure to get the
source to that user.  If a particular user can conveniently get the
source from you by anonymous FTP, fine--that does the job.  But not
every user is on a network.  The rest of the users are just as entitled
to get the source code from you.  So you have to be ready to send it
to them, on a disk or tape by snail mail.

Of course, it's easiest to just send the source with the binary in the
first place.

* I want to distribute binaries, but distributing complete source is
  inconvenient.  How about if I give users the diffs from the current
  FSF version along with the binaries, and suggest they get the base
  source from the FSF?

The idea may be well-intentioned, but this method of providing the
source doesn't really do the job.

A user that wants the source a year from now will probably be unable
to get the proper version from the FSF at that time.  We will have a
newer version, but the same diffs probably won't work with that.

So you need to provide complete sources, not just diffs.
You have to make sure the source is available to the user
for up to three years, as the GPL says.

--
Mail submissions for comp.os.linux.announce to: [email-masked]
PLEASE remember Keywords: and a short description of the software.